Unit tde58r_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UtRes_p, FFKDE58R_p, FFGDE58R_p, FFRDE58R_p, DE58R_p;

function tde58r: String;

implementation

function tde58r: String;
var
NX,J,K,I,NXM1,IERR :Integer;
XN,XK,H,GK :Real;
GN1,GK1 :Boolean;
ALP :Array [0..281] of Extended;
BET :Array [0..281] of Extended;
Y :Array [0..282] of Real;
YT :Array [0..282] of Real;
Z :Array [0..282] of Real;
X :Array [0..282] of Real;
GN :Array [0..1] of Real;
label
_1,_100,_20;
begin
Result := '';  {   }
NX := 283;
XN := 0.0;
XK := 1.57079632679;
H := 0.001;
X[0] := XN;
X[281] := XK-0.02;
X[282] := XK;
J := 0;
for K:=1 to 28 do
 begin
  for I:=1 to 10 do
   begin
    J := J+1;
_1:
    X[J+0] := X[J-1]+(I)*H;
   end;
 end;
GN1 := False;
GN[0] := 1000.0;
GN[1] := -4.0;
GK1 := True;
GK := 2.0;
DE58R(FFKDE58R,FFGDE58R,FFRDE58R,NX,X,GN1,GN,GK1,GK,Y,ALP,BET,IERR);
Result := Result + Format('%s',[' IERR=']);
Result := Result + Format('%2d ',[IERR]) + #$0D#$0A;
Result := Result + Format('%s',[' XN=']);
Result := Result + Format('%20.16f ',[XN]);
Result := Result + Format('%s',['      XK=']);
Result := Result + Format('%20.16f ',[XK]);
Result := Result + Format('%s',['      NX=']);
Result := Result + Format('%5d ',[NX]);
Result := Result + Format('%s',['      Y']);
Result := Result + Format('%s',['                YT']);
Result := Result + Format('%s',['                Z' + #$0D#$0A]);
NXM1 := NX-1;
for I:=1 to NX do
 begin
  YT[I-1] := 2.0*Sin(X[I-1]);
  Z[I-1] := Y[I-1]-YT[I-1];
_100:
 end;
for I:=1 to NXM1 do
 begin
  Result := Result + Format('%20.16f %20.16f %20.16f ',
 [Y[I-1],YT[I-1],Z[I-1]]) + #$0D#$0A;
_20:
 end;
Result := Result + Format('%20.16f %20.16f %20.16f ',
 [Y[NX-1],YT[NX-1],Z[NX-1]]) + #$0D#$0A;
UtRes('tde58r',Result);  {     tde58r.res }
exit;
end;

end.
